#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2300three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2300three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three23004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three23004xi = {
                1:'0x2232y-552z',
                2:'1031x1594y-1297z',
                3:'1032x2025y-350z',
                4:'1043x1881y-812z',
                5:'1047x1744y-1071z',
                6:'109x227y-2286z',
                7:'1121x1548y-1278z',
                8:'1138x1971y-327z',
                9:'1142x1696y-1051z',
                10:'1144x1831y-790z',
                11:'117x2234y-530z',
                12:'118x94y-2294z',
                13:'1208x1497y-1259z',
                14:'1236x1642y-1030z',
                15:'1241x1911y-304z',
                16:'1243x1775y-769z',
                17:'127x618y-2211z',
                18:'1293x1441y-1240z',
                19:'131x241y-2283z',
                20:'1327x1583y-1010z',
                21:'1339x1714y-747z',
                22:'133x1925y-1250z',
                23:'1341x1846y-281z',
                24:'1376x1380y-1220z',
                25:'1415x1519y-989z',
                26:'142x101y-2293z',
                27:'1431x1647y-725z',
                28:'1438x1776y-258z',
                29:'1455x1314y-1201z',
                30:'1499x1449y-968z',
                31:'1521x1575y-703z',
                32:'1530x1700y-236z',
                33:'1531x1244y-1181z',
                34:'156x253y-2280z',
                35:'1580x1375y-947z',
                36:'15x113y-2297z',
                37:'1603x1169y-1161z',
                38:'1606x1498y-681z',
                39:'1619x1619y-213z',
                40:'1658x1296y-926z',
                41:'165x631y-2205z',
                42:'1687x1416y-659z',
                43:'1703x1533y-190z',
                44:'1731x1213y-905z',
                45:'1764x1329y-637z',
                46:'1782x1443y-167z',
                47:'181x2072y-981z',
                48:'182x1765y-1463z',
                49:'182x263y-2277z',
                50:'1837x1239y-615z',
                51:'1857x1349y-144z',
                52:'1x68y-2298z',
                53:'204x643y-2198z',
                54:'209x271y-2274z',
                55:'21x29y-2299z',
                56:'234x2230y-508z',
                57:'235x1928y-1231z',
                58:'238x277y-2270z',
                59:'246x652y-2191z',
                60:'25x135y-2295z',
                61:'268x281y-2266z',
                62:'26x563y-2229z',
                63:'277x1767y-1445z',
                64:'288x658y-2184z',
                65:'290x2069y-960z',
                66:'299x282y-2262z',
                67:'32x1917y-1269z',
                68:'330x280y-2258z',
                69:'332x662y-2177z',
                70:'338x1925y-1211z',
                71:'351x2220y-485z',
                72:'362x276y-2254z',
                73:'372x1764y-1427z',
                74:'377x662y-2169z',
                75:'37x155y-2294z',
                76:'38x46y-2299z',
                77:'395x270y-2249z',
                78:'400x2060y-939z',
                79:'423x660y-2162z',
                80:'441x1916y-1191z',
                81:'467x1756y-1409z',
                82:'468x2203y-463z',
                83:'469x654y-2154z',
                84:'510x2045y-918z',
                85:'516x646y-2146z',
                86:'52x175y-2292z',
                87:'544x1902y-1172z',
                88:'563x1742y-1391z',
                89:'564x634y-2137z',
                90:'56x60y-2298z',
                91:'57x583y-2223z',
                92:'584x2180y-440z',
                93:'611x618y-2129z',
                94:'619x2025y-897z',
                95:'647x1882y-1152z',
                96:'658x1723y-1372z',
                97:'659x600y-2120z',
                98:'698x2150y-418z',
                99:'69x194y-2290z',
                100:'705x578y-2111z',
                101:'727x1998y-876z',
                102:'72x2068y-1002z',
                103:'748x1856y-1132z',
                104:'752x553y-2101z',
                105:'753x1699y-1354z',
                106:'75x73y-2297z',
                107:'797x524y-2092z',
                108:'7x11y-2299z',
                109:'7x91y-2298z',
                110:'811x2115y-395z',
                111:'834x1965y-855z',
                112:'847x1669y-1335z',
                113:'849x1824y-1112z',
                114:'88x211y-2288z',
                115:'91x602y-2217z',
                116:'923x2073y-372z',
                117:'939x1926y-833z',
                118:'93x1833y-1545z',
                119:'940x1634y-1316z',
                120:'949x1787y-1092z',
                121:'96x85y-2296z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2300three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2300three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2300THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2300THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2300THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2300THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2300THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three23004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2300THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2300THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2300THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three23004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three23004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2300THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2300THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2300THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2300three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                